<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="6">
					<a-form-item label="粮库名称" name="depotGrainName">
						<a-input v-model:value="searchFormState.depotGrainName" placeholder="请输入粮库名称"/>
					</a-form-item>
				</a-col>
				<a-col :span="6">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
		>
			<template #operator class="table-operator">
				<a-space>
					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('depotGrainAdd')">
						<template #icon>
							<plus-outlined/>
						</template>
						新增
					</a-button>
					<!--                    <a-button danger @click="deleteBatchDepotGrain()" v-if="hasPerm('depotGrainBatchDelete')">删除</a-button>-->
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.title === '预约码'">
					<a @click="qrFormRef.onOpen(record)">
						<img :src="record.qrCodePicUrl" class="record-img" style="max-height: 50px; max-width: 50px"/></a>
				</template>
				<template v-if="column.title === '扦样区'">
					<a-switch
						:loading="statusLoading"
						:checked="record.onSampling === '开启'"
						@change="onSamplingSwitch(record)"
					/>
				</template>
				<template v-if="column.title === '卸货区'">
					<a-switch
						:loading="statusLoading"
						:checked="record.onLade === '开启'"
						@change="onLadeSwitch(record)"
					/>
				</template>
				<template v-if="column.dataIndex === 'action'">
					<a-space>
						<a @click="formRef.onOpen(record)" v-if="hasPerm('depotGrainEdit')">编辑</a>
						<a-divider type="vertical" v-if="hasPerm(['depotGrainEdit', 'depotGrainDelete'], 'and')"/>
						<a-popconfirm title="确定要删除吗？" @confirm="deleteDepotGrain(record)">
							<a-button type="link" danger size="small" v-if="hasPerm('depotGrainDelete')">删除</a-button>
						</a-popconfirm>
					</a-space>
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="table.refresh(true)"/>
	<QrForm ref="qrFormRef"/>
</template>

<script setup name="depotGrain">
import {message} from 'ant-design-vue'
import Form from './form.vue'
import QrForm from './qrForm.vue'
import depotGrainApi from '@/api/biz/depotGrainApi'

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const qrFormRef = ref()
const statusLoading = ref(false)
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
const columns = [
	{
		title: '粮库名称',
		dataIndex: 'depotGrainName'
	},
	{
		title: '预约码'
	},
	{
		title: '扦样区',
	},
	{
		title: '卸货区',
	},
	{
		title: '在线状态',
		dataIndex: 'onlineState'
	},
	{
		title: '在线时间',
		dataIndex: 'onlineTime'
	},
	{
		title: '创建时间',
		dataIndex: 'createTime'
	},
]
// 操作栏通过权限判断是否显示
if (hasPerm(['depotGrainEdit', 'depotGrainDelete'])) {
	columns.push({
		title: '操作',
		dataIndex: 'action',
		align: 'center',
		width: '150px'
	})
}
let selectedRowKeys = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return depotGrainApi.depotGrainPage(Object.assign(parameter, searchFormParam)).then((data) => {
		return data
	})
}
// 扦样区开关
const onSamplingSwitch = (record) => {
	statusLoading.value = true
	depotGrainApi
		.depotGrainSet({"id": record.id, "onSampling": record.onSampling === '开启' ? '关闭' : '开启'})
		.then(() => {
			table.value.refresh(true)
		})
		.finally(() => {
			statusLoading.value = false
		})
}
// 卸货区开关
const onLadeSwitch = (record) => {
	statusLoading.value = true
	depotGrainApi
		.depotGrainSet({"id": record.id, "onLade": record.onLade === '开启' ? '关闭' : '开启'})
		.then(() => {
			table.value.refresh(true)
		})
		.finally(() => {
			statusLoading.value = false
		})
}
// 删除
const deleteDepotGrain = (record) => {
	let params = [
		{
			id: record.id
		}
	]
	depotGrainApi.depotGrainDelete(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchDepotGrain = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	const params = selectedRowKeys.value.map((m) => {
		return {
			id: m
		}
	})
	depotGrainApi.depotGrainDelete(params).then(() => {
		table.value.clearRefreshSelected()
	})
}
</script>
